//
// The class Calc
// stores the reverse polish notation of an expression
// and calculates its value using a stack of real numbers
//
#ifndef CALC_H
#define CALC_H

#include "RealStack.h"

class Calc {
public:
    enum Operation {   // Operations
        Plus,
        Minus,
        Mult,
        Div,
        Uminus,
        Double_const,
        X_value,
        No_operation
    };

    class action {
    public:
        enum Operation op;
        double value;

        action():
            op(No_operation),
            value(0.)
        {}

        action(Operation oper, double v = 0.):
            op(oper),
            value(v)
        {}
    };

private:
    // Array of actions (Reverse polish notation of expression)
    int actarray_capacity;
    int actarray_size;
    action* actarray;

    RealStack* stack;

public:
    Calc();
    ~Calc();

    void addAction(const action& act);
    const action& getAction(int i) const;
    int getActarraySize() const { return actarray_size; }
    void initialize();

    double calculate(double x); // Calcualte an expression in point x
};

extern Calc* theCalc;

#endif /* CALC_H */
