%{
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "scan1.h"
int yyerror(const char *s);

int yylex(YYSTYPE *lvalp) { /* For pure parser */
    int ret = yyylex();

    /* printf("yyylex returned %d\n", ret); */

    *lvalp = yylval;
    return ret;
}

%}

%pure_parser

%token X
%token LPARENT RPARENT
%token DOUBLE_CONST
%token ENDL
%left PLUS MINUS
%left MULT DIV
%nonassoc UMINUS

%start f

%%
f : e ENDL      { printf("=%lf\n", $1.double_value); }
  | error ENDL  { yyerrok; }
  ;

e : e PLUS e    {
                    $$.double_value = $1.double_value + $3.double_value;
                }
  | e MINUS e   {
                    $$.double_value = $1.double_value - $3.double_value;
                }
  | e MULT e    {
                    $$.double_value = $1.double_value * $3.double_value;
                }
  | e DIV e     {
                    $$.double_value = $1.double_value / $3.double_value;
                }
  | DOUBLE_CONST    { $$.double_value = $1.double_value; }
  | LPARENT e RPARENT { $$.double_value = $2.double_value; }
  | MINUS e %prec UMINUS { $$.double_value = (-$2.double_value); }
  | PLUS e %prec UMINUS { $$.double_value = $2.double_value; }
  ;

%%

int main() {
    char line[1024];
    while (true) {
        printf("Input an expression:\n");
        gets(line);
        if (*line == 0)
            break;
        set_scanner_buffer(line, strlen(line));
        yyparse();
    }
    return 0;
}

int yyerror(const char *s) {
    printf("%s\n", s);
    return 0;
}
