%{
/* Scanner for Calculator */

#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include "scan1.h"

YYSTYPE yylval;

static const char* scanner_buffer = 0;
static int scanner_buffer_length = 0;
static int scanner_pos = 0;

int scanner_input() {
    if (scanner_pos > scanner_buffer_length) {
        return 0;
    } else if (scanner_pos == scanner_buffer_length) {
        scanner_pos++;
        return '\n';
    } else {
        return scanner_buffer[scanner_pos++];
    }
}

void set_scanner_buffer(const char *line, int len) {
    scanner_buffer = line;
    scanner_buffer_length = len;
    scanner_pos = 0;
    yyrestart(0);
}

%}

EXPONENT        ((e|E)(\+|\-)?[0-9]+)

%%
[0-9]+(\.[0-9]*)?{EXPONENT}? {
                    LDoubleConst: ;
                    yylval.double_value = atof(yytext);
                    return DOUBLE_CONST;
                }
[0-9]*\.[0-9]+{EXPONENT}? { goto LDoubleConst; }

"+"             { return PLUS; }
"-"             { return MINUS; }
"*"             { return MULT; }
"/"             { return DIV; }
"x"|"X"         { return X; }
"("             { return LPARENT; }
")"             { return RPARENT; }
(" "|\t)+       { /* skip space */ }
\n              { return ENDL; }
.               {}

%%

int yywrap() { return 1; }
