#pragma once

class CGraphicDoc;

// CDrawArea view

class CDrawArea : public CView
{
    DECLARE_DYNCREATE(CDrawArea)

private:
    CFont   m_Font;
    CBrush  m_Brush;

    CPen    m_GrayPen;
    CPen    m_BlackPen;
    CPen    m_RedPen;

protected:
    CDrawArea();           // protected constructor used by dynamic creation
    virtual ~CDrawArea();

public:
    CGraphicDoc* GetDocument() const;
	virtual void OnDraw(CDC* pDC);      // overridden to draw this view
    void DrawAxes(CDC* pDC);
    void DrawGraph(CDC* pDC);
    void CalculateCoeff() const;

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	DECLARE_MESSAGE_MAP()
public:
    virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
    afx_msg BOOL OnEraseBkgnd(CDC* pDC);
    virtual void OnInitialUpdate();
    afx_msg void OnSize(UINT nType, int cx, int cy);
};


