// GraphicDoc.h : interface of the CGraphicDoc class
//

#include <afxtempl.h>

#pragma once

// Predefinition of classes
class CGraphicView;
class CDrawArea;

class CGraphicDoc : public CDocument
{
protected: // create from serialization only
    CGraphicDoc();
    DECLARE_DYNCREATE(CGraphicDoc)

// Attributes
public:
    CGraphicView*           m_pView;
    CDrawArea*              m_pDrawArea;
    CArray<CPoint, CPoint&> m_Curve;
    double                  m_xMin;
    double                  m_xMax;
    double                  m_yMin;
    double                  m_yMax;
    int                     m_DrawAreaWidth;
    int                     m_DrawAreaHeight;
    double                  m_CoeffX; // = m_DrawAreaWidth / (m_xMax-m_xMin)
    double                  m_CoeffY; // = m_DrawAreaHeight / (m_yMax-m_yMin)

    CString                 m_sFunction;
    BOOL                    m_bParseError;

// Operations
public:
    BOOL ParseFunction(LPCTSTR func);
    void ComputeCurve();
    double Function(double x) const;
    int MapX(double x) const;
    int MapY(double y) const;

// Overrides
    public:
    virtual BOOL OnNewDocument();
    virtual void Serialize(CArchive& ar);

// Implementation
public:
    virtual ~CGraphicDoc();
#ifdef _DEBUG
    virtual void AssertValid() const;
    virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
    DECLARE_MESSAGE_MAP()
};
