// GraphicView.h : interface of the CGraphicView class
//


#pragma once


class CGraphicView : public CFormView
{
    BOOL    m_bXMinChanged;
    BOOL    m_bXMaxChanged;
    BOOL    m_bYMinChanged;
    BOOL    m_bYMaxChanged;
    BOOL    m_bFuncChanged;

    int     m_OldSizeX;
    int     m_OldSizeY;

protected: // create from serialization only
    CGraphicView();
    DECLARE_DYNCREATE(CGraphicView)

public:
    enum{ IDD = IDD_GRAPHIC_FORM };

// Attributes
public:
    CGraphicDoc* GetDocument() const;

// Operations
public:
    void ShowXYMinMax();

// Overrides
    public:
virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
protected:
    virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
    virtual void OnInitialUpdate(); // called first time after construct

// Implementation
public:
    virtual ~CGraphicView();
#ifdef _DEBUG
    virtual void AssertValid() const;
    virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
    DECLARE_MESSAGE_MAP()
public:
    CString m_sXMax;
    CString m_sXMin;
    CString m_sYMin;
    CString m_sYMax;
    CString m_sFunc;
    afx_msg void OnBnClickedDraw();
    virtual BOOL Create(LPCTSTR lpszClassName, LPCTSTR lpszWindowName, DWORD dwStyle, const RECT& rect, CWnd* pParentWnd, UINT nID, CCreateContext* pContext = NULL);
    afx_msg void OnEnChangeXmin();
    afx_msg void OnEnKillfocusXmin();
    afx_msg void OnEnChangeXmax();
    afx_msg void OnEnKillfocusXmax();
    afx_msg void OnEnChangeYmin();
    afx_msg void OnEnKillfocusYmin();
    afx_msg void OnEnChangeYmax();
    afx_msg void OnEnKillfocusYmax();
    afx_msg void OnEnChangeFunc();
    afx_msg void OnEnKillfocusFunc();
    afx_msg void OnSize(UINT nType, int cx, int cy);
};

#ifndef _DEBUG  // debug version in GraphicView.cpp
inline CGraphicDoc* CGraphicView::GetDocument() const
   { return reinterpret_cast<CGraphicDoc*>(m_pDocument); }
#endif

